﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        bool pins_all = true;
        int trigger_pin = 255;
        int trigger_level = 0;
        int trigger_delay = 0;
        int trigger_count = 1;
        int[] sample_rate_timer = new int[] {0x50, 0,  1,  3, 9,  19,  39, 99};
        int sample_rate = 0;
        int samples = 5;
        int start_capture = 1;
        int wait_trigger = 0;
        int update_progress = 0;
        bool cancel_transfer = false;

        public Form1()
        {
            InitializeComponent();

            backgroundWorker1.WorkerReportsProgress = true;
            backgroundWorker1.WorkerSupportsCancellation = true;
            backgroundWorker1.DoWork += new DoWorkEventHandler(backgroundWorker1_DoWork);
            backgroundWorker1.ProgressChanged += new ProgressChangedEventHandler(backgroundWorker1_ProgressChanged);
            backgroundWorker1.RunWorkerAsync();

            backgroundWorker2.DoWork += new DoWorkEventHandler(backgroundWorker2_DoWork);
            backgroundWorker2.WorkerSupportsCancellation = true;
            backgroundWorker2.RunWorkerAsync();
        }

        // Start button
        private void button1_Click_1(object sender, EventArgs e)
        {
            // Update trigger/sample details to device
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo();
            startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            startInfo.FileName = "cpld_logic_analyer_v1.0_comm.exe";
            
            startInfo.Arguments = "/update " + Convert.ToString(trigger_pin) + " " +
                Convert.ToString(trigger_level) + " " +
                Convert.ToString(trigger_delay) + " " +
                Convert.ToString(trigger_count) + " " +
                Convert.ToString(sample_rate) + " " +
                Convert.ToString(samples) + " " +
                Convert.ToString(start_capture);
            process.StartInfo = startInfo;
            process.Start();

            wait_trigger = 1;
            cancel_transfer = false;
            backgroundWorker1.ReportProgress(0); // Reset progress bar
            wait_trigger_text.Visible = true; // Show waiting trigger text
        }

        // Selecting pin checkboxes
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_1.Checked)
            {
                trigger_pin |= (1 << 0);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 0);
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_2.Checked)
            {
                trigger_pin |= (1 << 1);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 1);
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_3.Checked)
            {
                trigger_pin |= (1 << 2);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 2);
            }
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_4.Checked)
            {
                trigger_pin |= (1 << 3);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 3);
            }
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_5.Checked)
            {
                trigger_pin |= (1 << 4);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 4);
            }
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_6.Checked)
            {
                trigger_pin |= (1 << 5);
            }
            else
            {
                pins_all = false;
                trigger_7.Checked = false;
                trigger_pin &= ~(1 << 5);
            }
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_7.Checked)
            {
                trigger_pin |= (1 << 6);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 6);
            }
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_8.Checked)
            {
                trigger_pin |= (1 << 7);
            }
            else
            {
                pins_all = false;
                trigger_all.Checked = false;
                trigger_pin &= ~(1 << 7);
            }
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_all.Checked)
            {
                trigger_1.Checked = trigger_2.Checked = trigger_3.Checked = trigger_4.Checked = trigger_5.Checked = trigger_6.Checked = trigger_7.Checked = trigger_8.Checked = pins_all = true;
            }
            else if (pins_all == true)
            {
                trigger_1.Checked = trigger_2.Checked = trigger_3.Checked = trigger_4.Checked = trigger_5.Checked = trigger_6.Checked = trigger_7.Checked = trigger_8.Checked = false;
            }
        }

        // Trigger level
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_high.Checked)
            {
                trigger_low.Checked = false;
                trigger_level = 1;
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (trigger_low.Checked)
            {
                trigger_high.Checked = false;
                trigger_level = 0;
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            trigger_delay = Convert.ToInt32(trigger_delay_box.Text);
            if (trigger_delay >= 254)
            {
                trigger_delay = 254;
                trigger_delay_box.Text = "254";
            }
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            trigger_count = Convert.ToInt32(trigger_count_box.Text);
            if (trigger_count >= 254)
            {
                trigger_count = 254;
                trigger_count_box.Text = "254";
            }
        }

        // Sample Rate/Depth
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            sample_rate = sample_rate_selection.SelectedIndex;
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            samples = sample_depth_selection.SelectedIndex;
        }

        // Stop button
        private void button2_Click(object sender, EventArgs e)
        {
            // Send cancel command in another command window
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo();
            startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            startInfo.FileName = "cpld_logic_analyer_v1.0_comm.exe";
            startInfo.Arguments = "/cancel";
            process.StartInfo = startInfo;
            process.Start();

            wait_trigger = 0;
            wait_trigger_text.Visible = false;
            backgroundWorker2.CancelAsync();
            cancel_transfer = true;
        }

        // Check for progress.txt file, read file length and convert that to a percent on the progress bar
        void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            while (true)
            {
                if (update_progress == 1)
                {
                    try
                    {
                        string path = "progress.txt";
                        FileInfo f = new FileInfo(path);
                        
                        int progress_percent = Convert.ToInt32(f.Length);
                        if (progress_percent > 99)
                        {
                            progress_percent = 100;
                        }
                        backgroundWorker1.ReportProgress(progress_percent);
                    }
                    catch (FileNotFoundException) {  }
                }

                System.Threading.Thread.Sleep(250);
            }

        }

        // Udate the progress bar
        void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            // The progress percentage is a property of e
            progressBar1.Value = e.ProgressPercentage;
        }
        
        // Keep checking in with device every 0.5s to see if we've triggered. If we have, then read out the data.
        void backgroundWorker2_DoWork(object sender, DoWorkEventArgs e)
        {
            while (true)
            {
                if (wait_trigger == 1)
                {
                    System.Diagnostics.Process process = new System.Diagnostics.Process();
                    System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo();
                    startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
                    startInfo.FileName = "cpld_logic_analyer_v1.0_comm.exe";
                    startInfo.Arguments = "/check";
                    process.StartInfo = startInfo;
                    process.Start();
                    process.WaitForExit();
                    int result = process.ExitCode;

                    if (result == 2 && wait_trigger == 1) 
                    {
                        update_progress = 1;

                        wait_trigger_text.Invoke(new MethodInvoker(delegate { wait_trigger_text.Visible = false; }));

                        System.Diagnostics.Process process1 = new System.Diagnostics.Process();
                        System.Diagnostics.ProcessStartInfo startInfo1 = new System.Diagnostics.ProcessStartInfo();
                        startInfo1.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden; 
                        startInfo1.FileName = "cpld_logic_analyer_v1.0_comm.exe";
                        startInfo1.Arguments = "/read " +
                        Convert.ToString(sample_rate) + " " +
                        Convert.ToString(samples);
                        process1.StartInfo = startInfo1;
                        process1.Start();
                        
                        // Allow the reading progress to be cancelled by another thread
                        while (!process1.HasExited)
                        {
                            if (cancel_transfer == true)
                            {
                                try
                                {
                                    process1.Kill();
                                }
                                catch { }
                                cancel_transfer = false;
                                continue;
                            }
                            else
                                Thread.Sleep(1000);
                        }
                        
                        wait_trigger = 0;
                        update_progress = 0;
                        System.Threading.Thread.Sleep(250);
                    }
                }

                System.Threading.Thread.Sleep(1000);
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_Load_1(object sender, EventArgs e)
        {

        }
    }
}
